# coding: utf-8

"""
    ABX Service - APIs

    Create or manage actions and their versions. Execute actions and flows.  This page describes the RESTful APIs for ABX Service. The APIs facilitate CRUD operations on creation and management of Actions and their Versions and also allow Execution of Actions and Flows.  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across ABX Service APIs.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/abx/api/resources/actions?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/abx/api/resources/actions?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/abx/api/resources/actions?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /abx/api/resources/actions?$filter=startswith(name, 'ABC')     /abx/api/resources/actions?$filter=toupper(name) eq 'ABCD-ACTION'     /abx/api/resources/actions?$filter=substringof(%27bc%27,tolower(name))     /abx/api/resources/actions?$filter=name eq 'ABCD' and actionType eq 'SCRIPT'   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ResourcesActionsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'metadata': 'dict(str, object)',
        'runtime': 'str',
        'source': 'str',
        'entrypoint': 'str',
        'description': 'str',
        'inputs': 'dict(str, object)',
        'memory_in_mb': 'int',
        'pre_polyglot_memory_limit_in_mb': 'int',
        'show_memory_alert': 'bool',
        'timeout_seconds': 'int',
        'dependencies': 'str',
        'compressed_content': 'list[str]',
        'action_type': 'str',
        'provider': 'str',
        'content_id': 'str',
        'configuration': 'dict(str, object)',
        'system': 'bool',
        'shared': 'bool',
        'scalable': 'bool',
        'async_deployed': 'bool',
        'id': 'str',
        'org_id': 'str',
        'project_id': 'str',
        'self_link': 'str'
    }

    attribute_map = {
        'name': 'name',
        'metadata': 'metadata',
        'runtime': 'runtime',
        'source': 'source',
        'entrypoint': 'entrypoint',
        'description': 'description',
        'inputs': 'inputs',
        'memory_in_mb': 'memoryInMB',
        'pre_polyglot_memory_limit_in_mb': 'prePolyglotMemoryLimitInMB',
        'show_memory_alert': 'showMemoryAlert',
        'timeout_seconds': 'timeoutSeconds',
        'dependencies': 'dependencies',
        'compressed_content': 'compressedContent',
        'action_type': 'actionType',
        'provider': 'provider',
        'content_id': 'contentId',
        'configuration': 'configuration',
        'system': 'system',
        'shared': 'shared',
        'scalable': 'scalable',
        'async_deployed': 'asyncDeployed',
        'id': 'id',
        'org_id': 'orgId',
        'project_id': 'projectId',
        'self_link': 'selfLink'
    }

    def __init__(self, name=None, metadata=None, runtime=None, source=None, entrypoint=None, description=None, inputs=None, memory_in_mb=None, pre_polyglot_memory_limit_in_mb=None, show_memory_alert=None, timeout_seconds=None, dependencies=None, compressed_content=None, action_type=None, provider=None, content_id=None, configuration=None, system=None, shared=None, scalable=None, async_deployed=None, id=None, org_id=None, project_id=None, self_link=None):  # noqa: E501
        """ResourcesActionsBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._metadata = None
        self._runtime = None
        self._source = None
        self._entrypoint = None
        self._description = None
        self._inputs = None
        self._memory_in_mb = None
        self._pre_polyglot_memory_limit_in_mb = None
        self._show_memory_alert = None
        self._timeout_seconds = None
        self._dependencies = None
        self._compressed_content = None
        self._action_type = None
        self._provider = None
        self._content_id = None
        self._configuration = None
        self._system = None
        self._shared = None
        self._scalable = None
        self._async_deployed = None
        self._id = None
        self._org_id = None
        self._project_id = None
        self._self_link = None
        self.discriminator = None
        self.name = name
        if metadata is not None:
            self.metadata = metadata
        self.runtime = runtime
        if source is not None:
            self.source = source
        self.entrypoint = entrypoint
        if description is not None:
            self.description = description
        if inputs is not None:
            self.inputs = inputs
        if memory_in_mb is not None:
            self.memory_in_mb = memory_in_mb
        if pre_polyglot_memory_limit_in_mb is not None:
            self.pre_polyglot_memory_limit_in_mb = pre_polyglot_memory_limit_in_mb
        if show_memory_alert is not None:
            self.show_memory_alert = show_memory_alert
        if timeout_seconds is not None:
            self.timeout_seconds = timeout_seconds
        if dependencies is not None:
            self.dependencies = dependencies
        if compressed_content is not None:
            self.compressed_content = compressed_content
        self.action_type = action_type
        if provider is not None:
            self.provider = provider
        if content_id is not None:
            self.content_id = content_id
        if configuration is not None:
            self.configuration = configuration
        if system is not None:
            self.system = system
        if shared is not None:
            self.shared = shared
        if scalable is not None:
            self.scalable = scalable
        if async_deployed is not None:
            self.async_deployed = async_deployed
        if id is not None:
            self.id = id
        self.org_id = org_id
        if project_id is not None:
            self.project_id = project_id
        if self_link is not None:
            self.self_link = self_link

    @property
    def name(self):
        """Gets the name of this ResourcesActionsBody.  # noqa: E501


        :return: The name of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ResourcesActionsBody.


        :param name: The name of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def metadata(self):
        """Gets the metadata of this ResourcesActionsBody.  # noqa: E501


        :return: The metadata of this ResourcesActionsBody.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this ResourcesActionsBody.


        :param metadata: The metadata of this ResourcesActionsBody.  # noqa: E501
        :type: dict(str, object)
        """

        self._metadata = metadata

    @property
    def runtime(self):
        """Gets the runtime of this ResourcesActionsBody.  # noqa: E501


        :return: The runtime of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._runtime

    @runtime.setter
    def runtime(self, runtime):
        """Sets the runtime of this ResourcesActionsBody.


        :param runtime: The runtime of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """
        if runtime is None:
            raise ValueError("Invalid value for `runtime`, must not be `None`")  # noqa: E501

        self._runtime = runtime

    @property
    def source(self):
        """Gets the source of this ResourcesActionsBody.  # noqa: E501


        :return: The source of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this ResourcesActionsBody.


        :param source: The source of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """

        self._source = source

    @property
    def entrypoint(self):
        """Gets the entrypoint of this ResourcesActionsBody.  # noqa: E501


        :return: The entrypoint of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._entrypoint

    @entrypoint.setter
    def entrypoint(self, entrypoint):
        """Sets the entrypoint of this ResourcesActionsBody.


        :param entrypoint: The entrypoint of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """
        if entrypoint is None:
            raise ValueError("Invalid value for `entrypoint`, must not be `None`")  # noqa: E501

        self._entrypoint = entrypoint

    @property
    def description(self):
        """Gets the description of this ResourcesActionsBody.  # noqa: E501


        :return: The description of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ResourcesActionsBody.


        :param description: The description of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def inputs(self):
        """Gets the inputs of this ResourcesActionsBody.  # noqa: E501


        :return: The inputs of this ResourcesActionsBody.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._inputs

    @inputs.setter
    def inputs(self, inputs):
        """Sets the inputs of this ResourcesActionsBody.


        :param inputs: The inputs of this ResourcesActionsBody.  # noqa: E501
        :type: dict(str, object)
        """

        self._inputs = inputs

    @property
    def memory_in_mb(self):
        """Gets the memory_in_mb of this ResourcesActionsBody.  # noqa: E501


        :return: The memory_in_mb of this ResourcesActionsBody.  # noqa: E501
        :rtype: int
        """
        return self._memory_in_mb

    @memory_in_mb.setter
    def memory_in_mb(self, memory_in_mb):
        """Sets the memory_in_mb of this ResourcesActionsBody.


        :param memory_in_mb: The memory_in_mb of this ResourcesActionsBody.  # noqa: E501
        :type: int
        """

        self._memory_in_mb = memory_in_mb

    @property
    def pre_polyglot_memory_limit_in_mb(self):
        """Gets the pre_polyglot_memory_limit_in_mb of this ResourcesActionsBody.  # noqa: E501


        :return: The pre_polyglot_memory_limit_in_mb of this ResourcesActionsBody.  # noqa: E501
        :rtype: int
        """
        return self._pre_polyglot_memory_limit_in_mb

    @pre_polyglot_memory_limit_in_mb.setter
    def pre_polyglot_memory_limit_in_mb(self, pre_polyglot_memory_limit_in_mb):
        """Sets the pre_polyglot_memory_limit_in_mb of this ResourcesActionsBody.


        :param pre_polyglot_memory_limit_in_mb: The pre_polyglot_memory_limit_in_mb of this ResourcesActionsBody.  # noqa: E501
        :type: int
        """

        self._pre_polyglot_memory_limit_in_mb = pre_polyglot_memory_limit_in_mb

    @property
    def show_memory_alert(self):
        """Gets the show_memory_alert of this ResourcesActionsBody.  # noqa: E501


        :return: The show_memory_alert of this ResourcesActionsBody.  # noqa: E501
        :rtype: bool
        """
        return self._show_memory_alert

    @show_memory_alert.setter
    def show_memory_alert(self, show_memory_alert):
        """Sets the show_memory_alert of this ResourcesActionsBody.


        :param show_memory_alert: The show_memory_alert of this ResourcesActionsBody.  # noqa: E501
        :type: bool
        """

        self._show_memory_alert = show_memory_alert

    @property
    def timeout_seconds(self):
        """Gets the timeout_seconds of this ResourcesActionsBody.  # noqa: E501


        :return: The timeout_seconds of this ResourcesActionsBody.  # noqa: E501
        :rtype: int
        """
        return self._timeout_seconds

    @timeout_seconds.setter
    def timeout_seconds(self, timeout_seconds):
        """Sets the timeout_seconds of this ResourcesActionsBody.


        :param timeout_seconds: The timeout_seconds of this ResourcesActionsBody.  # noqa: E501
        :type: int
        """

        self._timeout_seconds = timeout_seconds

    @property
    def dependencies(self):
        """Gets the dependencies of this ResourcesActionsBody.  # noqa: E501


        :return: The dependencies of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._dependencies

    @dependencies.setter
    def dependencies(self, dependencies):
        """Sets the dependencies of this ResourcesActionsBody.


        :param dependencies: The dependencies of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """

        self._dependencies = dependencies

    @property
    def compressed_content(self):
        """Gets the compressed_content of this ResourcesActionsBody.  # noqa: E501


        :return: The compressed_content of this ResourcesActionsBody.  # noqa: E501
        :rtype: list[str]
        """
        return self._compressed_content

    @compressed_content.setter
    def compressed_content(self, compressed_content):
        """Sets the compressed_content of this ResourcesActionsBody.


        :param compressed_content: The compressed_content of this ResourcesActionsBody.  # noqa: E501
        :type: list[str]
        """

        self._compressed_content = compressed_content

    @property
    def action_type(self):
        """Gets the action_type of this ResourcesActionsBody.  # noqa: E501


        :return: The action_type of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._action_type

    @action_type.setter
    def action_type(self, action_type):
        """Sets the action_type of this ResourcesActionsBody.


        :param action_type: The action_type of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """
        if action_type is None:
            raise ValueError("Invalid value for `action_type`, must not be `None`")  # noqa: E501
        allowed_values = ["SCRIPT", "REST_CALL", "REST_POLL", "FLOW", "VAULT", "CYBERARK"]  # noqa: E501
        if action_type not in allowed_values:
            raise ValueError(
                "Invalid value for `action_type` ({0}), must be one of {1}"  # noqa: E501
                .format(action_type, allowed_values)
            )

        self._action_type = action_type

    @property
    def provider(self):
        """Gets the provider of this ResourcesActionsBody.  # noqa: E501


        :return: The provider of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._provider

    @provider.setter
    def provider(self, provider):
        """Sets the provider of this ResourcesActionsBody.


        :param provider: The provider of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """

        self._provider = provider

    @property
    def content_id(self):
        """Gets the content_id of this ResourcesActionsBody.  # noqa: E501


        :return: The content_id of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._content_id

    @content_id.setter
    def content_id(self, content_id):
        """Sets the content_id of this ResourcesActionsBody.


        :param content_id: The content_id of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """

        self._content_id = content_id

    @property
    def configuration(self):
        """Gets the configuration of this ResourcesActionsBody.  # noqa: E501


        :return: The configuration of this ResourcesActionsBody.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._configuration

    @configuration.setter
    def configuration(self, configuration):
        """Sets the configuration of this ResourcesActionsBody.


        :param configuration: The configuration of this ResourcesActionsBody.  # noqa: E501
        :type: dict(str, object)
        """

        self._configuration = configuration

    @property
    def system(self):
        """Gets the system of this ResourcesActionsBody.  # noqa: E501


        :return: The system of this ResourcesActionsBody.  # noqa: E501
        :rtype: bool
        """
        return self._system

    @system.setter
    def system(self, system):
        """Sets the system of this ResourcesActionsBody.


        :param system: The system of this ResourcesActionsBody.  # noqa: E501
        :type: bool
        """

        self._system = system

    @property
    def shared(self):
        """Gets the shared of this ResourcesActionsBody.  # noqa: E501


        :return: The shared of this ResourcesActionsBody.  # noqa: E501
        :rtype: bool
        """
        return self._shared

    @shared.setter
    def shared(self, shared):
        """Sets the shared of this ResourcesActionsBody.


        :param shared: The shared of this ResourcesActionsBody.  # noqa: E501
        :type: bool
        """

        self._shared = shared

    @property
    def scalable(self):
        """Gets the scalable of this ResourcesActionsBody.  # noqa: E501


        :return: The scalable of this ResourcesActionsBody.  # noqa: E501
        :rtype: bool
        """
        return self._scalable

    @scalable.setter
    def scalable(self, scalable):
        """Sets the scalable of this ResourcesActionsBody.


        :param scalable: The scalable of this ResourcesActionsBody.  # noqa: E501
        :type: bool
        """

        self._scalable = scalable

    @property
    def async_deployed(self):
        """Gets the async_deployed of this ResourcesActionsBody.  # noqa: E501


        :return: The async_deployed of this ResourcesActionsBody.  # noqa: E501
        :rtype: bool
        """
        return self._async_deployed

    @async_deployed.setter
    def async_deployed(self, async_deployed):
        """Sets the async_deployed of this ResourcesActionsBody.


        :param async_deployed: The async_deployed of this ResourcesActionsBody.  # noqa: E501
        :type: bool
        """

        self._async_deployed = async_deployed

    @property
    def id(self):
        """Gets the id of this ResourcesActionsBody.  # noqa: E501


        :return: The id of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ResourcesActionsBody.


        :param id: The id of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def org_id(self):
        """Gets the org_id of this ResourcesActionsBody.  # noqa: E501


        :return: The org_id of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this ResourcesActionsBody.


        :param org_id: The org_id of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """
        if org_id is None:
            raise ValueError("Invalid value for `org_id`, must not be `None`")  # noqa: E501

        self._org_id = org_id

    @property
    def project_id(self):
        """Gets the project_id of this ResourcesActionsBody.  # noqa: E501


        :return: The project_id of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this ResourcesActionsBody.


        :param project_id: The project_id of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def self_link(self):
        """Gets the self_link of this ResourcesActionsBody.  # noqa: E501


        :return: The self_link of this ResourcesActionsBody.  # noqa: E501
        :rtype: str
        """
        return self._self_link

    @self_link.setter
    def self_link(self, self_link):
        """Sets the self_link of this ResourcesActionsBody.


        :param self_link: The self_link of this ResourcesActionsBody.  # noqa: E501
        :type: str
        """

        self._self_link = self_link

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResourcesActionsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResourcesActionsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
